<?php

namespace Bazookas\AdminBundle\AdminElements\Containers;

use Bazookas\AdminBundle\AdminElements\Base\BaseAdminElement;
use Bazookas\AdminBundle\AdminElements\Interfaces\AdminElementInterface;

class FlippablePanelContainer extends BaseAdminElement {

  public function __construct($children = [], $options = []) {
    parent::__construct($children, $options);

    //validate the children
    $this->validateChildren($children);
  }

  protected function getDefaultOptions() {
    $defaults = parent::getDefaultOptions();
    return array_merge($defaults, [
      'template' => 'BazookasAdminBundle:AdminElements/Containers:flippablePanelContainer.html.twig',
      // see _animations.scss for available animation styles
      'animationClass' => 'flip',
      'icon' => 'fa-pie-chart',
      'iconClass' => 'fa',
      'icon2' => 'fa-list',
      'iconClass2' => 'fa'
    ]);
  }

  /**
   * @param AdminElementInterface[] $children
   * @throws \Exception
   */
  private function validateChildren(array $children) {
    if (count($children) > 2) {
      //TODO throw a more specific exception
      throw new \Exception('A flippable container cannot have more than 2 children', 0);
    }
  }

  public function getIconClass2() {
    return $this->options['icon2'] . ' ' . $this->options['iconClass2'];
  }

}
