<?php

namespace Bazookas\AdminBundle\Controller\AdminController;

use Bazookas\AdminBundle\Form\AddCMSUserAdminType;
use Bazookas\AdminBundle\Form\EditCMSUserAdminType;
use Bazookas\AdminBundle\Controller\ListBaseController;

/**
 * @deprecated to be removed in v2, use BaseCMSUSerAdminController
 *
 * Class CMSUserAdminController
 * @package Bazookas\AdminBundle\Controller\AdminController
 */
class CMSUserAdminController extends ListBaseController
{

  function __construct() {
    // make sure parent construct is called!
    parent::__construct();

    $this->config->entity = 'BazookasAdminBundle:CMSUser';
    $this->config->entityName = 'admin.entities.CMSUser.name';
    // $this->config->addField('property', 'table-header', 'sortable', 'td class', 'template');
    $this->config->addField('username', 'admin.entities.CMSUser.fields.username');
    $this->config->addField('email', 'admin.entities.CMSUser.fields.email');
    $this->config->addField('locale', 'admin.entities.CMSUser.fields.locale');
    $this->config->addField('groups', 'admin.entities.CMSUser.fields.groups', false, 'text-left', 'BazookasAdminBundle:List/Fields/CMSUser:_groups.html.twig');
    $this->config->setAddForm(AddCMSUserAdminType::class);
    $this->config->setEditForm(EditCMSUserAdminType::class);

    $this->config
      ->setShowFilter(true)
      ->setMaintainFilterState(true)

      ->addBasicTextFilter('username', 'admin.entities.CMSUser.fields.username')
      ->addBasicTextFilter('email', 'admin.entities.CMSUser.fields.email')
    ;


  }

  protected function checkAccess($_action, $_id) {
    // when returning false on any action, there is no real need to set these
    // these are only usefull for showing/hiding the buttons
    // $this->config->setAccess(self::ACTION_ADD, false);
    // $this->config->setAccess(self::ACTION_EDIT, false);
    // $this->config->setAccess(self::ACTION_REMOVE, false);
    return $this->isGranted('ROLE_ADD_USER');
  }

}
