<?php

namespace Bazookas\AdminBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;

/**
 * @deprecated use Bazookas\AdminBundle\Controller\Base\BaseDashboardController
 * Class DashboardController
 * @package Bazookas\AdminBundle\Controller
 */
class DashboardController extends Controller
{
  public function indexAction(Request $request)
  {
    $redirectParams = array();

    $user = $this->getUser();
    //if a user is logged in
    //get their preferred language and switch to that language
    if (!empty($user)) {
      //only auto change the language if we've just logged in
      $referrer = $request->headers->get('referer');
      if (strpos($referrer, 'login') !== false) {
        $locale = $user->getLocale();

        if (!empty($locale)) {
          $redirectParams['_locale'] = $locale;
        }
      }
    }

    if ($this->isGranted('ROLE_CMS_USER')) {
      return $this->redirectToRoute('bazookas_admin_dashboard', $redirectParams);
    }
    else {
      return $this->redirectToRoute('fos_user_security_login', $redirectParams);
    }
  }

  public function dashboardAction(Request $request)
  {
    // TODO Basic implementation of dashboard 'widgets', needs more lovin'
    return $this->render('BazookasAdminBundle:Dashboard:index.html.twig');
  }
}
