<?php

namespace Bazookas\AdminBundle\Dashboard\Elements;

use Bazookas\AdminBundle\Dashboard\Base\BaseDashboardElement;

/**
 * @deprecated
 *
 * Class StatisticOverviewElement
 * @package Bazookas\AdminBundle\Dashboard\Elements
 */
class StatisticOverviewElement extends BaseDashboardElement {

  public $iconClass;

  public $data;

  public function __construct($children = [], $options = []) {
    parent::__construct($children, $options);
    $this->class = 'panel-' . $this->options['panelColor'] . ' ' . $this->options['class'];
    $this->iconClass = $this->options['icon'] . ' ' . $this->options['iconClass'];

    $this->data = $this->processData($options['data']);
  }

  protected function getDefaultOptions() {
    $defaults = parent::getDefaultOptions();
    return array_merge($defaults, [
      'template' => 'BazookasAdminBundle:Dashboard\Elements:statisticOverviewElement.html.twig',
      'class' => 'panel panel-colorful',
      'panelColor' => 'primary',
      'icon' => 'fa-user',
      'iconClass' => 'fa fa-4x mar-all',
      'data' => []
    ]);
  }

  protected function processData(array $data) {
    $maxIndex = 0;
    $minIndex = count($data) - 1;
    //highlight the lowest value in red and the highest value in green
    for($i = 0; $i < count($data); $i++) {
      $data[$i]['badgeColor'] = 'primary';

      if ($data[$i]['value'] > $data[$maxIndex]['value'] || $i == $maxIndex) {
        $maxIndex = $i;
        $data[$maxIndex]['badgeColor'] = 'primary';
        $data[$i]['badgeColor'] = 'success';
      }

      if ($data[$i]['value'] <= $data[$minIndex]['value']) {
        $minIndex = $i;
        $data[$minIndex]['badgeColor'] = 'primary';
        $data[$i]['badgeColor'] = 'danger';
      }
    }

    return $data;
  }

}


