<?php

namespace Bazookas\AdminBundle\EventListener;

use FOS\UserBundle\Event\FormEvent;
use Symfony\Component\EventDispatcher\EventSubscriberInterface;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Symfony\Component\HttpKernel\Exception\HttpExceptionInterface;
use Symfony\Component\Routing\Generator\UrlGeneratorInterface;
use FOS\UserBundle\FOSUserEvents;

class FOSUserResettingListener implements EventSubscriberInterface
{
  private $router;
  private $tokenTtl;
  public function __construct(UrlGeneratorInterface $router)
  {
    $this->router = $router;
  }

  public static function getSubscribedEvents()
  {
    return array(
      FOSUserEvents::RESETTING_RESET_SUCCESS => 'onResettingResetSuccess'
    );
  }
  public function onResettingResetSuccess(FormEvent $event)
  {
    // Customize your response object to display the exception details

    $url = $this->router->generate('bazookas_admin_dashboard');
    $response = new RedirectResponse($url);

    // Send the modified response object to the event
    $event->setResponse($response);
  }
}
