<?php
namespace Bazookas\AdminBundle\Form\Extension;

use Symfony\Component\Form\AbstractTypeExtension;
use Symfony\Component\Form\Extension\Core\Type\FormType;
use Symfony\Component\Form\Extension\Core\Type\DateTimeType;

use Symfony\Component\Form\FormView;
use Symfony\Component\Form\FormInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class DateTimeTypeExtension extends AbstractTypeExtension
{
  public function getExtendedType() {
    return DateTimeType::class;
  }

  public function configureOptions(OptionsResolver $resolver)
  {
    $resolver
      ->setDefined([
        'datetimepicker'
      ])
    ;
  }

  /**
    * Pass the image URL to the view
    *
    * @param FormView $view
    * @param FormInterface $form
    * @param array $options
    */
   public function buildView(FormView $view, FormInterface $form, array $options)
   {
      if (isset($options['datetimepicker'])) {
        $view->vars['datetimepicker'] = $options['datetimepicker'];
      }
   }
}
