<?php
namespace Bazookas\AdminBundle\Form\Extension;

use Symfony\Component\Form\AbstractTypeExtension;
use Symfony\Component\Form\Extension\Core\Type\FormType;

use Symfony\Component\Form\FormView;
use Symfony\Component\Form\FormInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class ToolTipExtension extends AbstractTypeExtension
{
  public function getExtendedType() {
    return FormType::class;
  }

  public function configureOptions(OptionsResolver $resolver)
  {
    $resolver
      ->setDefined(array(
        'tooltip_title',
        'tooltip_content',
        'tooltip_type',
        'tooltip_placement',
        'tooltip_trigger'
      ))
      ->setDefaults(array(
        'tooltip_title' => false,
        'tooltip_content' => false,
        'tooltip_type' => 'tooltip',
        'tooltip_placement' => 'right',
        'tooltip_trigger' => 'hover'
      ))
    ;
  }

  /**
    * Pass the image URL to the view
    *
    * @param FormView $view
    * @param FormInterface $form
    * @param array $options
    */
   public function buildView(FormView $view, FormInterface $form, array $options)
   {
      if (isset($options['tooltip_title'])) {
        $view->vars['tooltip_title'] = $options['tooltip_title'];
        $view->vars['tooltip_content'] = $options['tooltip_content'];
        $view->vars['tooltip_type'] = $options['tooltip_type'];
        $view->vars['tooltip_placement'] = $options['tooltip_placement'];
        $view->vars['tooltip_trigger'] = $options['tooltip_trigger'];
      }
   }
}
