<?php

namespace Bazookas\AdminBundle\PageBuilder\Interfaces;

use Bazookas\CommonBundle\Entity\Interfaces\EntityInterface;
use Symfony\Component\Form\Form;
use Symfony\Component\HttpFoundation\Request;

interface FormPageBuilderInterface
{

  /**
   * @return Form
   */
  public function getForm();

  /**
   * @param Form $form
   * @return $this
   */
  public function setForm(Form $form);

  /**
   * Get the entity object
   * @return EntityInterface
   */
  public function getEntity();

  /**
   * Set the entity object
   * @param EntityInterface $entity
   * @return mixed
   */
  public function setEntity(EntityInterface $entity);

  /**
   * Get the id of the entity
   * @return mixed
   */
  public function getEntityId();

  /**
   * Set the id of the entity
   * @param $entityId
   * @return mixed
   */
  public function setEntityId($entityId);

  /**
   * @param Request $request
   * @return boolean
   */
  public function handleForm(Request $request);
}
