<?php

namespace Bazookas\AdminBundle\Repository;

use Bazookas\AdminBundle\Entity\CMSUser;
use Bazookas\AdminBundle\Repository\Base\BaseRepository;

class CMSUserRepository extends BaseRepository
{

  public function getEntityClass() {
    return CMSUser::class;
  }

  public function findAllExcluding($id) {
    $qb = $this->createQueryBuilder('u');
    $qb
      ->select('u')
      ->where($qb->expr()->neq('u.id', ':id'))
      ->setParameter('id', $id)
    ;

    return $qb->getQuery()->getResult();
  }

  public function createListQueryBuilder(array $fields, array $params) {
    $qb = $this->createQueryBuilder('e');
    $qb
      ->addSelect('groups')
      ->leftJoin('e.groups', 'groups')
    ;

    return $qb;
  }
}
