<?php

namespace Bazookas\CommonBundle\Entity\Interfaces;

use Symfony\Component\Security\Core\Authorization\AuthorizationChecker;
use Bazookas\CommonBundle\Entity\Base\BaseCMSUser;

interface EntityInterface {

  /**
  * This function is invoked right before an entity is persisted on an add form submission
  */
  public function preFormPersist();

  /**
  * This function is invoked right before an entity is merged on an edit form submission
  */
  public function preFormUpdate();

  public function getCreated();

  public function setCreated(\DateTime $created = null);

  public function getModified();

  public function setModified(\DateTime $modified = null);

  public function toHumanReadable($locale = 'nl');

}
