<?php

namespace Bazookas\CommonBundle\Entity\Traits;

trait BaseEntityTrait {

  use TimestampableTrait;
  use BaseAccessControlTrait;

  /**
   * @return mixed
   */
  public function getId() {
    return $this->id;
  }

  /**
   * @param mixed $id
   * @return $this
   */
  public function setId($id) {
    $this->id = $id;
    return $this;
  }

  /**
   * @deprecated to be removed in v2
   * This function is invoked right before an entity is persisted on an add form submission
   */
  public function preFormPersist() {
    //Overwrite this
  }

  /**
   * @deprecated to be removed in v2
   * This function is invoked right before an entity is merged on an edit form submission
   */
  public function preFormUpdate() {
    $this->preFormPersist();
  }

  public function toHumanReadable($locale = 'nl') {
    return get_class($this)." {id: 1}";
  }

  public function allowForceDelete() {
    return true;
  }
}
