<?php

namespace Bazookas\CommonBundle\Entity\Traits;

use Doctrine\ORM\Mapping as ORM;

trait ResettablePasswordTrait {

  /**
   * @ORM\Column(type="string", nullable=true)
   */
  private $forgotPasswordHash;

  /**
   * @ORM\Column(type="datetime", nullable=true)
   */
  private $forgotPasswordExpiry;

  public function getForgotPasswordHash()
  {
    return $this->forgotPasswordHash;
  }

  public function setForgotPasswordHash($forgotPasswordHash = null)
  {
    $this->forgotPasswordHash = $forgotPasswordHash;

    if (!empty($forgotPasswordHash)) {
      $forgotPasswordExpiry = new \DateTime();
      $forgotPasswordExpiry->modify('+ 2 weeks');
    } else {
      $forgotPasswordExpiry = null;
    }
    $this->setForgotPasswordExpiry($forgotPasswordExpiry);

    return $this;
  }

  public function getForgotPasswordExpiry()
  {
    return $this->forgotPasswordExpiry;
  }

  public function setForgotPasswordExpiry(\DateTime $forgotPasswordExpiry = null)
  {
    $this->forgotPasswordExpiry = $forgotPasswordExpiry;
    return $this;
  }
}
