<?php
namespace Bazookas\CommonBundle\EventListeners\Exception;

use Bazookas\CommonBundle\Services\Exception\Events\LoggableExceptionEvent;
use Symfony\Bridge\Monolog\Logger;
use Bazookas\CommonBundle\Services\Exception\Interfaces\LoggableExceptionInterface;

class LoggableExceptionsListener
{
  private $logger;

  public function __construct(Logger $logger) {
    $this->logger = $logger;
  }

  public function onLoggableExceptionEvent(LoggableExceptionEvent $event) {
    $exception = $event->getException();
    if ($exception->isLoggable()) {
      $severity = $exception->getLoggingSeverity();

      switch($severity) {
        case LoggableExceptionInterface::PRIORITY_INFO:
          $this->logger->info($exception);
          break;
        case LoggableExceptionInterface::PRIORITY_ERROR:
          $this->logger->error($exception);
          break;
        case LoggableExceptionInterface::PRIORITY_CRITICAL:
          $this->logger->critical($exception);
          break;
      }
    }
  }
}
