<?php
namespace Bazookas\CommonBundle\Exception\Base;

use Bazookas\CommonBundle\Exception\Interfaces\EntityExceptionInterface;
use Exception;

abstract class BaseEntityException extends \RuntimeException implements EntityExceptionInterface  {
  protected $code;
  protected $message;
  protected $payload;

  // Redefine the exception so message isn't optional
  public function __construct($message, $code = 0, Exception $previous = null, $payload = null) {
    $this->message = $message;
    $this->payload = $payload;

    // make sure everything is assigned properly
    parent::__construct($message, $code, $previous);
  }

  // custom string representation of object
  public function __toString() {
    return get_class($this) . ": {$this->message}\n in '".$this->getFile()."' at line ".$this->getLine().".";
  }

  public function getPayload() {
    return $this->payload;
  }

  public abstract function getName();

}
