<?php

namespace Bazookas\CommonBundle\Exception;

use Bazookas\CommonBundle\Exception\Base\BaseException;
use Bazookas\CommonBundle\Exception\Base\BaseExceptionMap;
use Exception;

class NotImplementedException extends BaseException {

  public function __construct($message = '', $code = BaseExceptionMap::GENERAL_ERROR, Exception $previous = null) {
    if (empty($message)) {
      $message = 'Function \'' . debug_backtrace()[1]['function'] .'\' is not implemented in class \'' . debug_backtrace()[1]['class'] . '\' on line ' . debug_backtrace()[0]['line'] . '.';
    }

    $this->message = $message;
    parent::__construct($message, $code, $previous);
  }

}
