<?php

namespace Bazookas\CommonBundle\Services\Util\HttpClient;

use Bazookas\CommonBundle\Exception\ConnectionException;

/**
 * @deprecated
 */
class HttpClient {

  protected function prepareRequest(Request $request) {
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, false); //follow redirects
    curl_setopt($ch, CURLOPT_URL, $request->getUrl());
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

    //set the curl options
    foreach ($request->getCurlOptions() as $key => $value) {
      curl_setopt($ch, $key, $value);
    }

    //add the data if necessary
    if (
      $request->getMethod() === HttpUtil::METHOD_POST ||
      $request->getMethod() === HttpUtil::METHOD_PUT
    ) {
      curl_setopt($ch, CURLOPT_POSTFIELDS, $request->getData());
    }

    //set the request method
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, $request->getMethod());

    return $ch;
  }

  public function getResponse(Request $request) {
    $ch = $this->prepareRequest($request);

    $rawOutput = curl_exec($ch);
    if ($rawOutput !== false) {
      $status = curl_getinfo($ch, CURLINFO_HTTP_CODE);
      $type = curl_getinfo($ch, CURLINFO_CONTENT_TYPE);
      $type = explode(';', $type);
      $type = trim($type[0]);

      $response = new Response();
      $response
        ->setStatusCode($status)
        ->setRawData($rawOutput)
        ->setDataType($type)
      ;

      curl_close($ch);
      return $response;
    } else {
      throw new ConnectionException('connection error: ' . print_r(curl_getinfo($ch), true));
    }
  }

  public function getBinaryFileResponse(Request $request, $fileSavePath) {
    $options = $request->getCurlOptions();
    if (!isset($options[CURLOPT_BINARYTRANSFER])) {
      $options[CURLOPT_BINARYTRANSFER] = true;
    }
    $request->setCurlOptions($options);

    $ch = $this->prepareRequest($request);
    $rawOutput = curl_exec($ch);

    curl_close($ch);

    curl_close($ch);
    if (file_exists($fileSavePath)) {
      unlink($fileSavePath);
    }
    $fp = fopen($fileSavePath, 'x');
    fwrite($fp, $rawOutput);
    fclose($fp);

    return $fileSavePath;
  }
}
