# Cron bundle

Contains a command to run cron tasks defined in database. Will run multiple iterations for one "execution" to make shorter intervals possible with crontab.

This bundle will also add an admin page for adding and editing cron tasks.

## Installing
### With composer
Add the following to composer.json (composer will ask authentication for private bundles the first time you install a bazookas bundle)
```json
    "repositories": [
        {
            "type": "vcs",
            "url": "https://github.com/Bazookastudios/BazookasCronBundle.git"
        }
    ],
```

And then: `composer require bazookas/cron-bundle`

### As a git submodule
Use this command in the root of your repository to add this bundle as a submodule.

```bash
git submodule add -b master --name CronBundle https://github.com/Bazookastudios/BazookasCronBundle.git ./src/Bazookas/CronBundle
```

## Activating the installation
### Activate in AppKernel.php

```
      new Bazookas\AdminBundle\BazookasCronBundle(),
```

### Import in app/config.yml

```
    - { resource: "@BazookasCronBundle/Resources/config/menu.yml" }
```

### Optional config parameters

And their default values.
```
parameters:
  debug_mailer_from: simon@bazookas.be
  debug_mailer_to: simon@bazookas.be
```

`%debug_mailer_to%` can contain an array of addresses

### Add to app/routing.yml

```YAML
bazookas_cron:
    resource: "@BazookasCronBundle/Resources/config/routing.yml"
    prefix:   /{_locale}/admin
    defaults:
        _locale: "%locale%"
    requirements:
        _locale: "%requiredlocales%"

```

### Activing the bundle in production

Add the `crons:run` command to `crontab -e` as follows:
```sh
*/1 * * * * php /var/www/staging/ugent/prevend/bin/console crons:run --env=prod >> /var/log/cron_staging_prevend.log 2>&1
```
