<?php

namespace WebsiteBundle\Controller\Admin;

use Bazookas\AdminBundle\Controller\Base\BaseAdminListController;
use Bazookas\AdminBundle\PageBuilder\Interfaces\ListPageBuilderInterface;
use Bazookas\AdminBundle\PageBuilder\ListPageBuilder;
use Symfony\Component\HttpFoundation\Request;
use WebsiteBundle\Entity\Test;
use WebsiteBundle\Form\Admin\TestAdminType;
use WebsiteBundle\Security\Roles;

class TestAdminController extends BaseAdminListController
{

  protected function getEntityClass()
  {
    return Test::class;
  }

  protected function modifyListBuilder(Request $request, ListPageBuilderInterface $builder)
  {
    /**
     * @var ListPageBuilder $builder
     */
    $builder = parent::modifyListBuilder($request, $builder);

    $builder
      ->addField('name')
      ->addField('type', [
        'template' => 'WebsiteBundle:List\Fields:testType.html.twig'
      ])
    ;
    return $builder;
  }

  protected function getFormClass($action) {
    switch($action) {
      case self::ACTION_ADD:
      case self::ACTION_EDIT:
        return TestAdminType::class;
      default:
        return null;
    }
  }

  protected function hasAccess($action) {
    switch($action) {
      case self::ACTION_LIST:
      case self::ACTION_EDIT:
        return $this->isGranted(Roles::ROLE_ADMIN);
      case self::ACTION_ADD:
        return $this->isGranted(Roles::ROLE_SUPER_ADMIN);
      default:
        return false;
    }
  }

}
