<?php

namespace WebsiteBundle\Repository;

use Bazookas\AdminBundle\Repository\Base\BaseRepository;
use WebsiteBundle\Entity\Experiment;

class ExperimentConditionRepository extends BaseRepository
{

  public function getConditionCount(Experiment $experiment) {
    $qb = $this->createQueryBuilder('experimentCondition');
    $qb
      ->select('COUNT(participants.id) AS participantCount', 'experimentCondition AS condition')

      ->leftJoin('experimentCondition.participants', 'participants')

      ->andWhere($qb->expr()->eq('experimentCondition.experiment', ':experiment'))
      ->setParameter('experiment', $experiment)
      ->groupBy('experimentCondition.id')
      ->orderBy('participantCount', 'ASC')
    ;

    return $qb->getQuery()->getResult();
  }

}
