var bazookas = bazookas || {};

bazookas.compact = (function () {
  var self = {},
    language,
    now;


  self.init = function (context) {
    $('#acceptRules').click(checkBoxClickHandler);
    $('#acceptConsent').click(checkBoxClickHandler);
    $('#content') // or something else
      .on('focus', '.compact input, .compact textarea', compactFocusHandler)
      .on('blur', '.compact input, .compact textarea', compactBlurHandler)
      .on('input', '.compact input, .compact textarea', compactInputHandler);

    $('#content input, #content textarea').each(function() {
      if ($(this).attr('type') !== 'hidden') {
        $(this).val("").trigger('input');
      }
    });
  };

  function checkBoxClickHandler(e){
    var $button = $('.submit__button');
    if($('#acceptRules')[0].checked && $('#acceptConsent')[0].checked) {
      $button.removeClass('disabled');
    } else {
      $button.addClass('disabled');
    }
  }

  // event handlers
  function compactFocusHandler(e) {
    var target = $(this);
    var formItem = target.closest('.form-item');
    formItem.addClass('focus');
  }

  function compactBlurHandler(e) {
    var target = $(this);
    var formItem = target.closest('.form-item');
    formItem.removeClass('focus');
  }

  function compactInputHandler(e) {
    var target = $(this);
    var formItem = target.closest('.form-item');
    if ($.trim(target.val()) === '') {
      formItem.addClass('empty');
    } else {
      formItem.removeClass('empty');
    }
  }

  return self;
})();

