<?php

namespace WebsiteBundle\Services\Data;

use Bazookas\APIFrameworkBundle\Services\Data\Base\BaseDataService;
use Doctrine\ORM\EntityManager;
use Symfony\Component\HttpFoundation\ParameterBag;
use WebsiteBundle\Entity\UnlockedQuote;

class QuoteDataService extends BaseDataService
{
  /**
   * @var EntityManager
   */
  private $entityManager;

  public function __construct(EntityManager $entityManager) {
    $this->entityManager = $entityManager;
  }

  public function markAsViewed(ParameterBag $params, ParameterBag $extraParams) {
    $unlockedId = $params->get('unlockedQuoteId');
    $participant = $extraParams->get('user');

    $quoteRepo = $this->entityManager->getRepository(UnlockedQuote::class);
    $quoteRepo->markAsViewed($unlockedId, $participant);

    //Need to return something so that valid json is generated
    return [];
  }

}
