<?php

namespace Bazookas\AdminBundle\AdminElements\Elements;

use Bazookas\AdminBundle\AdminElements\Base\BaseAdminElement;

class StatisticOverviewElement extends BaseAdminElement {

  public $data;

  public function __construct($children = [], $options = []) {
    parent::__construct($children, $options);

    $this->data = $this->processData($options['data']);
  }

  protected function getDefaultOptions() {
    $defaults = parent::getDefaultOptions();
    return array_merge($defaults, [
      'template' => 'BazookasAdminBundle:AdminElements\Elements:statisticOverviewElement.html.twig',
      'class' => 'panel panel-colorful',
      'panelColor' => 'primary',
      'icon' => 'fa-user',
      'iconClass' => 'fa fa-4x mar-all',
      'data' => [],
      'highlightValues' => true
    ]);
  }

  protected function processData(array $data) {
    if ($this->options['highlightValues']) {
      $maxIndex = 0;
      $maxIndeces = [];
      $minIndex = count($data) - 1;
      $minIndeces = [];
      //highlight the lowest value in red and the highest value in green
      for($i = 0; $i < count($data); $i++) {
        $data[$i]['badgeColor'] = 'primary';

        if ($data[$i]['value'] > $data[$maxIndex]['value'] || $i == $maxIndex) {
          $maxIndex = $i;
          $maxIndeces = [$maxIndex];
        } else if ($data[$i]['value'] === $data[$maxIndex]['value']) {
          $maxIndeces[] = $i;
        }

        if ($data[$i]['value'] < $data[$minIndex]['value']) {
          $minIndex = $i;
          $minIndeces = [$minIndex];
        } else if ($data[$i]['value'] === $data[$minIndex]['value']) {
          $minIndeces[] = $i;
        }
      }

      $minColor = 'danger';
      $maxColor = 'success';
      if ($data[$minIndex]['value'] == $data[$maxIndex]['value']) {
        $minColor = 'primary';
        $maxColor = 'primary';
      }

      foreach($minIndeces as $index) {
        $data[$index]['badgeColor'] = $minColor;
      }

      foreach($maxIndeces as $index) {
        $data[$index]['badgeColor'] = $maxColor;
      }
    }

    return $data;
  }

  public function getClass() {
    return 'panel-' . $this->options['panelColor'] . ' ' . $this->options['class'];
  }

}
