<?php
namespace Bazookas\AdminBundle\Filter;

/**
 * @deprecated
 *
 * Helper class to configure a single entity field
 **/
class FilterField {

  //field types
  const TYPE_TEXT = 'text';
  const TYPE_NUMBER = 'number';
  const TYPE_BOOLEAN = 'boolean';

  /**
   * @var string the property name of the field to render
   **/
  public $field;

  /**
   * @var string the translation key to use in the label
   **/
  public $label;

  /**
   * @var string the translation key to use in the data attribute of the option
   **/
  public $type;

  /**
   * @var array the allowed operators
   */
  public $operators;

  public function getField()
  {
    return $this->field;
  }

  public function setField($field)
  {
    $this->field = $field;

    return $this;
  }

  public function getLabel()
  {
    return $this->label;
  }

  public function setLabel($label)
  {
    $this->label = $label;

    return $this;
  }

  public function getType()
  {
    return $this->type;
  }

  public function setType($type)
  {
    $this->type = $type;

    return $this;
  }

  /**
   * Helper function for rendering, returns a string representation of the given value
   * @param string the original value
   * @return string parsed value
   **/
  public function getStringValue($value) {
    // REVIEW add more string conversions or use custom templates?
    if (is_array($value)) {
      return implode($value, ', ');
    }
    else if ($value instanceof \DateTime) {
      return $value->format('Y-m-d H:i:s');
    }
    else if ($value instanceof \Doctrine\ORM\PersistentCollection) {
      return '?';
    }
    else if (is_object($value)) {
      return '?';
    }
    return $value;
  }

  public function setOperators($operators) {
    $this->operators = $operators;
  }

  public function getOperators() {
    if (!empty($this->operators)) {
      return $this->operators;
    } else {
      return $this->getDefaultOperators();
    }
  }

  public static function getDefaultOperators() {
    return array(
      'admin.filter.operator.equals' => Filter::OPERATOR_EQUALS,
      'admin.filter.operator.notEquals' => Filter::OPERATOR_NOT_EQUALS,
      'admin.filter.operator.like' => Filter::OPERATOR_LIKE,
      'admin.filter.operator.notLike' => Filter::OPERATOR_NOT_LIKE,
      'admin.filter.operator.greaterThan' => Filter::OPERATOR_GREATER_THAN,
      'admin.filter.operator.greaterThanEquals' => Filter::OPERATOR_GREATER_THAN_EQUALS,
      'admin.filter.operator.lessThan' => Filter::OPERATOR_LESS_THAN,
      'admin.filter.operator.lessThanEquals' => Filter::OPERATOR_LESS_THAN_EQUALS,
    );
  }
}
