<?php
namespace Bazookas\AdminBundle\Filter;


use Symfony\Component\Validator\Constraints as Assert;

/**
 * Helper class to hold a single filter
 **/
class ListFilter {

  //Operators
  const OPERATOR_EQUALS = 'eq';
  const OPERATOR_NOT_EQUALS = 'neq';
  const OPERATOR_LIKE = 'like';
  const OPERATOR_NOT_LIKE = 'notLike';
  const OPERATOR_GREATER_THAN = 'gt';
  const OPERATOR_GREATER_THAN_EQUALS = 'gte';
  const OPERATOR_LESS_THAN = 'lt';
  const OPERATOR_LESS_THAN_EQUALS = 'lte';

  /**
   * @Assert\NotBlank
   * @var string
   */
  private $field;

  /**
   * @Assert\NotBlank
   * @var string
   */
  private $operator;

  /**
   * @var Mixed
   */
  private $value;

  /**
   * @var string
   */
  private $type = 'text';

  /**
   * @var ListFilterField[]
   */
  private $filterFields;

  public function getField()
  {
    return $this->field;
  }

  public function setField($field)
  {
    $this->field = $field;

    return $this;
  }

  public function getOperator()
  {
    return $this->operator;
  }

  public function setOperator($operator)
  {
    $this->operator = $operator;

    return $this;
  }

  public function getValue()
  {
    return $this->value;
  }

  public function setValue($value)
  {
    $this->value = $value;

    return $this;
  }

  public function getType()
  {
    return $this->type;
  }

  public function setType($type)
  {
    $this->type = $type;
    return $this;
  }

  /**
   * @return ListFilterField[]
   */
  public function getFilterFields()
  {
    return $this->filterFields;
  }

  /**
   * @param ListFilterField[] $filterFields
   * @return $this
   */
  public function setFilterFields(array $filterFields)
  {
    $this->filterFields = $filterFields;

    return $this;
  }

}
