<?php

namespace Bazookas\AdminBundle\Filter;

class ListFilterCollection
{

  /**
   * @var ListFilter[]
   */
  protected $filters;

  /**
   * @return ListFilter[]
   */
  public function getFilters()
  {
    return $this->filters;
  }

  /**
   * @param array $filters
   * @return $this
   */
  public function setFilters(array $filters)
  {
    $this->filters = $filters;

    return $this;
  }

  public function addFilter(ListFilter $filter) {
    array_push($this->filters, $filter);
    return $this;
  }

  public function removeFilter(ListFilter $filter) {
    $index = array_search($filter, $this->filters);
    if ($index !== false) {
      array_splice($this->filters, $index, 1);
    }
    return $this;
  }

}
