<?php
namespace Bazookas\AdminBundle\Form\Extension;

use Symfony\Component\Form\AbstractTypeExtension;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Component\OptionsResolver\Options;
use Symfony\Component\Form\FormView;
use Symfony\Component\Form\FormInterface;

use Symfony\Component\Form\Extension\Core\Type\FormType;

/**
* This class extends the default form type
**/
class ConditionallyVisibleExtension extends AbstractTypeExtension
{
  public function getExtendedType()
  {
    return FormType::class;
  }

  public function configureOptions(OptionsResolver $resolver)
  {
    $resolver
      ->setDefaults([
        'conditionallyVisible' => null,
        'conditionallyDetached' => null,
        'conditionalScope' => 'body',
        'conditionalOperator' => 'and',
      ])
      ->setAllowedValues('conditionalOperator', ['and', 'or'])
    ;
  }
  public function buildView(FormView $view, FormInterface $form, array $options)
  {
    if (!empty($options['conditionallyVisible']))
    {
      $view->vars['conditionallyVisible'] = $options['conditionallyVisible'];
      $view->vars['conditionalScope'] = $options['conditionalScope'];
      $view->vars['conditionalOperator'] = $options['conditionalOperator'];
    }
    if (!empty($options['conditionallyDetached']))
    {
      $view->vars['conditionallyDetached'] = $options['conditionallyDetached'];
    }
  }
}
