<?php

namespace Bazookas\AdminBundle\Repository\Interfaces\Notification;

use Bazookas\AdminBundle\Entity\Interfaces\Notification\NotificationInterface;
use Bazookas\CommonBundle\Entity\Base\BaseCMSUser;
use Doctrine\ORM\Query;

interface CMSNotificationRepositoryInterface
{

  /**
   * @param BaseCMSUser $user
   * @param int $hydrationMode
   * @return NotificationInterface[]
   */
  public function getCMSNotifications(BaseCMSUser $user, $hydrationMode = Query::HYDRATE_ARRAY);

  /**
   * @param BaseCMSUser $user
   * @param array $ids
   */
  public function markNotificationsAsViewed(BaseCMSUser $user, array $ids);

  /**
   * @param BaseCMSUser $user
   * @param array $ids
   */
  public function removeNotifications(BaseCMSUser $user, array $ids);
}
