### Adding filtering to your list table

Once you've created a basic admin list page you can add filter fields in your `modifyListBuilder` function as follows:

```php
/**
* @param Request $request
* @param ListPageBuilderInterface $builder
* @return ListPageBuilderInterface
*/
protected function modifyListBuilder(Request $request, ListPageBuilderInterface $builder) {
    $builder
       ->addTextFilterField('name')
    ;
    
    return $builder;
}
```

No further configuration is required for the filtering functionality.

Note that the default `ListPageBuilder` also supports the following filter field types:

- `public function addBooleanFilterField($fieldName, array $options = [])`
- `public function addTextFilterField($fieldName, array $options = [])`
- `public function addNumberFilterField($fieldName, array $options = [])`
- `public function addChoiceFilterField($fieldName, array $options = ['choices' => $keyValueChoiceArray])`
