## Menu configuration

It is possible to define an admin menu through config files. The config is parse in the DependencyInjection classes and passed to the parameters to be used in a twig extension. The twig extension normalizes the config data before the actual rendering happens.

Example usage of menu configuration:
```YAML
bazookas_admin:
  menu:
    # main represents the sidebar menu
    main:
      # example:
      #   type: (required) header, link or submenu
      #   label: (required) translation key to use as display
      #   route: (required for 'link' items) route key
      #   icon: any icon class like "fa fa-dashboard" or "ti-dashboard"
      #   children: only applicable with "submenu" type, a list of child items in the same format as this one
      #   roles: An optional array of user roles that can access this menu items. This overrides the default check using the security.access_map (use this if security is defined in controllers instead of config)
      example_header:
        type: header
        label: menu.main.header
        roles: [ROLE_ADMIN]
      dashboard:
        type: link
        label: menu.main.dashboard
        route: bazookas_admin_dashboard
        icon: ti-dashboard
      # NOTE submenus can be nested as deep as you want, but just keep it real, people
      submenu_test:
        type: submenu
        label: menu.main.submenu
        icon: ti-dashboard
        children:
          submenu:
            type: submenu
            label: menu.main.submenu
            children:
              item1:
                type: link
                label: menu.main.item
                route: bazookas_admin_dashboard
              item2:
                type: link
                label: menu.main.item
                route: bazookas_admin_dashboard
```
