<?php

namespace Bazookas\AdminBundle\Tests\DataFixtures;

use Bazookas\AdminBundle\DataFixtures\ORM\AdminFixtures;
use Bazookas\AdminBundle\Entity\CMSUser;
use Bazookas\AdminBundle\Entity\CMSUserGroup;
use Doctrine\Common\Persistence\ObjectManager;

class AdminTestDataFixtures extends AdminFixtures
{
  public function load(ObjectManager $manager)
  {
    $basicGroup = new CMSUserGroup();
    $basicGroup->setName('Basic user');
    $basicGroup->setRoles(array('ROLE_CMS_USER'));
    $manager->persist($basicGroup);

    $user = new CMSUser();
    $password = base64_encode(random_bytes(6));

    $user
      ->setUsername('basicUser1')
      ->setPlainPassword($password)
      ->setName('basicUser1')
      ->setSurname('Bazookas')
      ->setLocale('nl')
      ->setEmail('test1@bazookas.be')
      ->setEnabled(TRUE)
      ->addGroup($basicGroup)
    ;
    $this->setReference('user-basic1', $user);
    $manager->persist($user);

    $adminGroup2 = new CMSUserGroup();
    $adminGroup2->setName('Administrator');
    $adminGroup2->setRoles(array('ROLE_ADMIN'));
    $manager->persist($adminGroup2);

    $user2 = new CMSUser();
    $user2
      ->setUsername('adminUser1')
      ->setPlainPassword($password)
      ->setName('adminUser1')
      ->setSurname('Bazookas')
      ->setLocale('nl')
      ->setEmail('test2@bazookas.be')
      ->setEnabled(TRUE)
      ->addGroup($adminGroup2)
    ;
    $this->setReference('user-admin1', $user2);
    $manager->persist($user2);

    parent::load($manager);
  }
}
