<?php
namespace Bazookas\AdminBundle\Twig;

use Bazookas\AdminBundle\Entity\CMSUser;
use Doctrine\ORM\EntityManagerInterface;

class UserExtension extends \Twig_Extension
{

  private $entityManager;

  public function __construct(EntityManagerInterface $manager)
  {
    $this->entityManager = $manager;
  }

  /**
   * Get Twig functions defined in this extension.
   *
   * @return array
   */
  public function getFunctions()
  {
    return array(
      new \Twig_SimpleFunction('get_impersonable_users', [$this, 'getImpersonableUsers']),
    );
  }

  public function getImpersonableUsers($user) {
    $repository = $this->entityManager->getRepository(CMSUser::class);
    return $repository->findAllExcluding($user->getId());
  }

  public function getName() {
    return 'bazookas_admin_user_extension';
  }

}
