## General information

In general when using the APIFrameworkBundle to create api calls your code should follow the general API structure:

The request is processed by a `controller`. This controller in turn requests a `data service` to carry out the bulk of the work. The data service may request data from the database through a `repository`. This repository is responsible for interacting with the database and retrieving data. This does **not** include any formatting that is required to generate the output of the api call you are making.

If a data service needs to format data before passing it back to controller it must ask a `BaseFormatter` or an `OutputFormatter` to format the data.

The roles of each classes are therefore as follows:
- **Controller** is responsible for receiving requests and sending responses
- **Data service** is responsible for data processing or manipulation. And will tend to coordinate interaction between different **Repositories**, **Formatters** or other services.
- **Repository** is responsible for interacting with the database and retrieving and persisting data
- **BaseFormatter** or **OutputFormatter** is responsible for formatting the data that should be passed in the response that will be sent by the **Controller**

The above code still follows the old structure that was first adopted in MF, this is no longer the preferred structure as outlined above. All new api calls should follow this structure wherever possible.

A general overview of the structure:

![General API structure](./General API structure.jpg)
