<?php

namespace Bazookas\CommonBundle\Entity\Base;

use Bazookas\CommonBundle\Entity\Interfaces\ResettablePasswordInterface;
use Bazookas\CommonBundle\Entity\Traits\ResettablePasswordTrait;
use Doctrine\ORM\Mapping as ORM;

/**
* @ORM\MappedSuperclass
*/
abstract class BaseAppUser extends BaseUser implements ResettablePasswordInterface {

  use ResettablePasswordTrait;

  /**
   * Unmapped field
   * @var string
   */
  private $plainPassword;

  /**
   * @return string
   */
  public function getPlainPassword() {
    return $this->plainPassword;
  }

  /**
   * @param string $password
   * @return $this
   */
  public function setPlainPassword(string $password) {
    $this->plainPassword = $password;
    return $this;
  }

}
