# PrependYamlLoader

`Bazookas\CommonBundle\DependencyInjection\Loader\PrependYamlLoader`

This loader will load a config file, loop over the configurations and prepend them to the container. This way you can configure bundles from the outside.

For example, the media bundle wants to define some preset image styles for the imagine bundle. Use this to keep the app/config.yml clean and project specific.

## How to use

1. Implement `Symfony\Component\DependencyInjection\Extension\PrependExtensionInterface` in bundle's DependencyInjection
2. Create a `PrependYamlLoader` in the `prepend` method (required for prepend interface)
3. Load the required config files
    - these files can contain regular yaml as in the app/config.yml

That's it + there's an example of the prepend method below:

```php
public function prepend(ContainerBuilder $container)
{
  $loader = new PrependYamlLoader($container, new FileLocator(__DIR__.'/../Resources/config'));
  $loader->load('config.yml');
}
```
