<?php

namespace Bazookas\CommonBundle\Services\Util\HttpClient;

/**
 * @deprecated To be removed in v2
 */
class Request {

  private $headers;

  private $url;

  private $method;

  private $queryArgs;

  private $data;

  private $curlOptions;

  public function __construct($url, $method, $queryArgs = [], $data = [], $headers = [], $curlOptions = []) {
    $this->url = $url;
    $this->method =$method;
    $this->queryArgs = $queryArgs;

    if (empty($headers)) {
      $this->headers = [
        'Content-Type: ' . HttpUtil::CONTENT_TYPE_JSON
      ];
    } else {
      $this->headers = $headers;
    }

    $this->setData($data);
    $this->curlOptions = $curlOptions;
  }

  public function getUrl()
  {
    if (!empty($this->queryArgs)) {
      $urlParams = '?';
      $urlParams .= http_build_query($this->queryArgs, '', '&');
      return $this->url . $urlParams;
    }

    return $this->url;
  }

  public function setUrl($url)
  {
    $this->url = $url;

    return $this;
  }

  public function getMethod()
  {
    return $this->method;
  }

  public function setMethod($method)
  {
    $this->method = $method;

    return $this;
  }

  public function getQueryArgs()
  {
    return $this->queryArgs;
  }

  public function setQueryArgs(array $queryArgs)
  {
    $this->queryArgs = $queryArgs;

    return $this;
  }

  public function getData()
  {
    return $this->data;
  }

  public function setData($data)
  {
    //get the content type header
    switch(HttpUtil::getContentType($this->headers)) {
      case HttpUtil::CONTENT_TYPE_XML:

        //TODO implement this

        throw new \Exception('Not implemented');


      case HttpUtil::CONTENT_TYPE_WWW_FORM_URLENCODED:
        $this->data = http_build_query($data, null, '&', PHP_QUERY_RFC1738);
        break;
      default:
        $this->data = json_encode($data);
    }

    return $this;
  }

  public function getCurlOptions()
  {
    if (empty($this->curlOptions)) {
      return [
        CURLOPT_HTTPHEADER => $this->headers
      ];
    }

    return $this->curlOptions;
  }

  /**
   * @param array an associative array containting CURL_CONSTANT => value pairs
   * @return $this
   */
  public function setCurlOptions(array $curlOptions)
  {
    $this->curlOptions = $curlOptions;

    return $this;
  }
}
