<?php

namespace Bazookas\CommonBundle\Services\Util\HttpClient;

use Bazookas\CommonBundle\Exception\ConnectionException;

/**
 * @deprecated To be removed in v2
 */
class Response
{
  private $statusCode;

  private $data;

  private $rawData;

  private $dataType;

  public function getStatusCode()
  {
    return $this->statusCode;
  }

  public function setStatusCode($statusCode)
  {
    $this->statusCode = $statusCode;

    return $this;
  }

  public function getData()
  {
    if (is_null($this->data)) {
      $type = HttpUtil::getContentType(['Content-Type: ' . $this->dataType]);
      switch ($type) {
        case HttpUtil::CONTENT_TYPE_JSON:
          $this->data = json_decode($this->rawData, true);
          break;
        case HttpUtil::CONTENT_TYPE_HTML:
          throw new ConnectionException('Invalid API response format: ' . print_r($this->rawData, true));
          break;
        case HttpUtil::CONTENT_TYPE_XML:
          $this->data = simplexml_load_string($this->rawData);
          break;
        default:
          throw new ConnectionException('Unsupported Mime type: ' . $type);
      }
    }

    return $this->data;
  }

  public function setData($data)
  {
    $this->data = $data;

    return $this;
  }

  public function getRawData()
  {
    return $this->rawData;
  }

  public function setRawData($rawData)
  {
    $this->rawData = $rawData;

    return $this;
  }

  public function getDataType()
  {
    return $this->dataType;
  }

  public function setDataType($dataType)
  {
    $this->dataType = $dataType;

    return $this;
  }

}
