<?php

namespace Bazookas\IntegrationsBundle\DependencyInjection;

use Symfony\Component\Config\Definition\Builder\TreeBuilder;
use Symfony\Component\Config\Definition\ConfigurationInterface;

/**
 * This is the class that validates and merges configuration from your app/config files.
 *
 * To learn more see {@link http://symfony.com/doc/current/cookbook/bundles/configuration.html}
 */
class Configuration implements ConfigurationInterface
{
  /**
   * {@inheritdoc}
   */
  public function getConfigTreeBuilder()
  {
    $treeBuilder = new TreeBuilder();
    $rootNode = $treeBuilder->root('bazookas_integrations');

    $rootNode
      ->children()
        ->arrayNode('facebook')
          ->addDefaultsIfNotSet()
          ->children()
            ->integerNode('appId')
            ->end()
            ->scalarNode('appSecret')
            ->end()
            ->scalarNode('facebookIdField')
              ->defaultValue('id')
            ->end()
            ->variableNode('fields')
            ->end()
          ->end()
        ->end()
      ->end()
    ;

    return $treeBuilder;
  }
}
