<?php
/**
 * Created by PhpStorm.
 * User: robbeclerckx
 * Date: 29/10/16
 * Time: 21:03
 */

namespace Bazookas\MediaBundle\Services\Data;


use Bazookas\APIFrameworkBundle\Entity\APIFileUpload;
use Bazookas\APIFrameworkBundle\Exception\ElementNotFoundException;
use Bazookas\CommonBundle\Services\Util\ConnectorService;
use Bazookas\MediaBundle\Entity\Base\BaseMedia;
use Bazookas\MediaBundle\Entity\Image;
use Doctrine\ORM\EntityManagerInterface;
use Imagine\Image\ImagineInterface;
use Liip\ImagineBundle\Imagine\Cache\CacheManager;
use Bazookas\MediaBundle\Repository\Base\BaseMediaRepository;
use Bazookas\MediaBundle\Services\Media\Image\ImageService;
use Symfony\Bundle\FrameworkBundle\Routing\Router;
use Symfony\Component\HttpFoundation\ParameterBag;

class APICallbackService extends ImageService
{

  /**
   * @var BaseMediaRepository
   */
  private $repository;

  /**
   * @var EntityManagerInterface
   */
  private $entityManager;

  public function __construct(ConnectorService $connector, EntityManagerInterface $entityManager, BaseMediaRepository $repository, CacheManager $imagineCacheManager, ImagineInterface $imagine, Router $router, $mediaSettings) {
    parent::__construct($connector, $imagineCacheManager, $imagine, $router, $mediaSettings);
    $this->repository = $repository;
    $this->entityManager = $entityManager;
  }

  public function uploadComplete(ParameterBag $parameterBag) {
    $mediaID = $parameterBag->get('id');
    if (empty($mediaID)) {
      // TODO throw error?
      return;
    }

    /* @var $targetUpload APIFileUpload */
    $targetUpload = $parameterBag->get('APIFileUpload');

    /** @var BaseMedia $media */
    $media = $this->repository->find($mediaID);
    $media
      ->setPath($targetUpload->getFile())
      ->setRelativeUrl($targetUpload->getRelativeUrl())
      ->setUrl($targetUpload->getFinalUrl())
    ;

    if (method_exists($media, 'setAspectRatio')) {
      try {
        $media->setAspectRatio($this->getAspectRatioAsString($targetUpload->getFile()));
      }
      catch (\Exception $e) {
        // meh?
      }
    }

    // make sure the entity is flushed
    $this->entityManager->flush();
  }
}
