bazookas.listBulkAction = (function() {
  var self = {},
    initialised = false,
    selected = [],
    bulkActionsEnabled = false;

  self.init = function (context) {
    bazookas.main
      .findInContext('.magic-checkbox.js-bulk-select-all', context)
      .initElements(initListeners);

    bazookas.main
      .findInContext('.js-bulk-edit-field', context)
      .initElements(editFormListeners);
  };

  function initListeners() {
    if (!initialised) {
      $('.magic-checkbox.js-bulk-select-all').change(selectAllHandler);
      $('.magic-checkbox.js-bulk-select-checkbox').change(selectHandler);
      $('.js-bulk-action').click(bulkActionHandler);

      if (selected.length === 0) {
        $('.js-bulk-action').each(function() {
          $(this).addClass('disabled');
        });
      }

      //trigger a change to make sure that the initial state is set correctly
      $('.magic-checkbox.js-bulk-select-checkbox').change();
    }

    initialised = true;
  }

  function editFormListeners() {
    if (!initialised) {
      var editFields = $('.js-bulk-edit-field');
      editFields.change(toggleFieldEnabled);

      //trigger a change to make sure that the initial state is set correctly
      editFields.change();
    }
    initialised = true;
  }

  function selectAllHandler(event) {
    var $target = $(event.target);
    if ($target.is(':checked')) {
      $('.magic-checkbox.js-bulk-select-checkbox').each(function() {
        $(this).prop('checked', true);
        $(this).change();
      });

      $('.magic-checkbox.js-bulk-select-all').each(function() {
        $(this).prop('checked', true);
      });
    } else {
      $('.magic-checkbox.js-bulk-select-checkbox').each(function() {
        $(this).prop('checked', false);
        $(this).change();
      });

      $('.magic-checkbox.js-bulk-select-all').each(function() {
        $(this).prop('checked', false);
      });
    }
  }

  function selectHandler(event) {
    var $target = $(event.target);
    if ($target.is(':checked')) {
      selected.push($target.data('id'));
    } else {
      var index = selected.indexOf($target.data('id'));
      if (index > -1) {
        selected.splice(index, 1)
      }
    }

    if (bulkActionsEnabled && selected.length === 0) {
      $('.js-bulk-action').each(function() {
        var $this = $(this);
        if (!$this.hasClass('disabled')) {
          $(this).addClass('disabled');
        }
      });
      bulkActionsEnabled = false;
    } else if (selected.length > 0) {
      $('.js-bulk-action').each(function() {
        $(this).removeClass('disabled');
        bulkActionsEnabled = true;
      });
    }
  }

  function bulkActionHandler(event) {
    var $target = $(event.target);
    event.preventDefault();

    if (!$target.hasClass('disabled')) {
      //generate url string
      var paramString = '?';
      for(var i=0; i  < selected.length; i++) {
        if (i===0) {
          paramString = '?ids[0]=' + selected[i];
        } else {
          paramString = paramString + '&ids['+i+']=' + selected[i];
        }
      }

      window.location = $target.data('href') + paramString;
    }
  }

  function toggleFieldEnabled(event) {
    var $target = $(event.target);

    var $formGroup = $target.closest('.form-group');
    // var $input = $formGroup.find('input.form-control');
    var $input = $formGroup.find('input:not(.js-bulk-edit-field)');
    var $element = null;

    if ($input.length > 0) {
      $element = $input;
    } else {
      $element = $formGroup.find('.select2');
    }

    if ($target.is(':checked')) {
      $element.prop('disabled', false);
    } else {
      $element.prop('disabled', true);
    }
  }

  return self;
})();
